Index: /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90
===================================================================
--- /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9352)
+++ /branches/2018/dev_r8864_nemo_v3_6_ZTILDE/NEMOGCM/NEMO/OPA_SRC/DOM/domvvl.F90	(revision 9353)
@@ -9,4 +9,5 @@
    !!                                          vvl option includes z_star and z_tilde coordinates
    !!            3.6  !  2014-11  (P. Mathiot) add ice shelf capability
+   !!                 !  2018-01  (J. Chanut) improve ztilde robustness
    !!----------------------------------------------------------------------
    !!   'key_vvl'                              variable volume
@@ -33,4 +34,5 @@
    USE wrk_nemo        ! Memory allocation
    USE timing          ! Timing
+   USE bdy_oce         ! ocean open boundary conditions
 
    IMPLICIT NONE
@@ -48,21 +50,31 @@
    LOGICAL , PUBLIC                                      :: ln_vvl_ztilde = .FALSE.             ! ztilde vertical coordinate
    LOGICAL , PUBLIC                                      :: ln_vvl_layer = .FALSE.              ! level  vertical coordinate
-   LOGICAL , PUBLIC                                      :: ln_vvl_ztilde_as_zstar = .FALSE.    ! ztilde vertical coordinate
-   LOGICAL , PUBLIC                                      :: ln_vvl_zstar_at_eqtor = .FALSE.     ! ztilde vertical coordinate
-   LOGICAL , PUBLIC                                      :: ln_vvl_kepe = .FALSE.               ! kinetic/potential energy transfer
+   LOGICAL                                               :: ln_vvl_ztilde_as_zstar = .FALSE.    ! ztilde vertical coordinate
+   LOGICAL                                               :: ln_vvl_zstar_at_eqtor = .FALSE.     ! revert to zstar at equator
+   LOGICAL                                               :: ln_vvl_zstar_on_shelf =.FALSE.      ! revert to zstar on shelves
+   LOGICAL                                               :: ln_vvl_kepe =.FALSE.                ! kinetic/potential energy transfer
+   LOGICAL                                               :: ln_vvl_adv_fct =.FALSE.             ! Centred thickness advection
+   LOGICAL                                               :: ln_vvl_adv_cn2 =.TRUE.              ! FCT thickness advection
+   LOGICAL                                               :: ln_vvl_dbg = .FALSE.                ! debug control prints
+   LOGICAL                                               :: ln_vvl_lap                          ! Laplacian thickness diffusion
+   LOGICAL                                               :: ln_vvl_blp                          ! Bilaplacian thickness diffusion 
+   LOGICAL                                               :: ln_vvl_regrid                       ! ensure layer separation 
    !                                                                                            ! conservation: not used yet
-   REAL(wp)                                              :: rn_ahe3                   ! thickness diffusion coefficient
+   REAL(wp)                                              :: rn_ahe3_lap               ! thickness diffusion coefficient (Laplacian)
+   REAL(wp)                                              :: rn_ahe3_blp               ! thickness diffusion coefficient (Bilaplacian)
    REAL(wp)                                              :: rn_rst_e3t                ! ztilde to zstar restoration timescale [days]
    REAL(wp)                                              :: rn_lf_cutoff              ! cutoff frequency for low-pass filter  [days]
    REAL(wp)                                              :: rn_zdef_max               ! maximum fractional e3t deformation
-   LOGICAL , PUBLIC                                      :: ln_vvl_dbg = .FALSE.      ! debug control prints
 
    !! * Module variables
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: un_td, vn_td                       ! thickness diffusion transport
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: hdiv_lf                            ! low frequency part of hz divergence
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tilde_e3t_b, tilde_e3t_n           ! baroclinic scale factors
-   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tilde_e3t_a, dtilde_e3t_a          ! baroclinic scale factors
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_e3t                        ! retoring period for scale factors
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_hdv                        ! retoring period for low freq. divergence
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: un_td, vn_td              ! thickness diffusion transport
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: hdivn_lf,  un_lf,  vn_lf  ! 1st order filtered arrays         
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tilde_e3t_b, tilde_e3t_n  ! baroclinic scale factors
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tilde_e3t_a, dtilde_e3t_a ! baroclinic scale factors
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_e3t               ! restoring period for scale factors
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_hdv               ! restoring period for low freq. divergence
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: tildemask                 ! mask tilde tendency
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: hsm, dsm                  ! 
+   INTEGER         , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: i_int_bot
 
    !! * Substitutions
@@ -85,4 +97,5 @@
          ALLOCATE( tilde_e3t_b(jpi,jpj,jpk)  , tilde_e3t_n(jpi,jpj,jpk) , tilde_e3t_a(jpi,jpj,jpk) ,   &
             &      dtilde_e3t_a(jpi,jpj,jpk) , un_td  (jpi,jpj,jpk)     , vn_td  (jpi,jpj,jpk)     ,   &
+            &      i_int_bot(jpi,jpj), tildemask(jpi,jpj), hsm(jpi,jpj), dsm(jpi,jpj), &
             &      STAT = dom_vvl_alloc        )
          IF( lk_mpp             )   CALL mpp_sum ( dom_vvl_alloc )
@@ -92,5 +105,8 @@
       ENDIF
       IF( ln_vvl_ztilde ) THEN
-         ALLOCATE( frq_rst_e3t(jpi,jpj) , frq_rst_hdv(jpi,jpj) , hdiv_lf(jpi,jpj,jpk) , STAT= dom_vvl_alloc )
+         ALLOCATE( frq_rst_e3t(jpi,jpj) , frq_rst_hdv(jpi,jpj),  &
+            &        hdivn_lf(jpi,jpj,jpk),  &
+            &           un_lf(jpi,jpj,jpk),  &
+            &           vn_lf(jpi,jpj,jpk),  STAT= dom_vvl_alloc )
          IF( lk_mpp             )   CALL mpp_sum ( dom_vvl_alloc )
          IF( dom_vvl_alloc /= 0 )   CALL ctl_warn('dom_vvl_alloc: failed to allocate arrays')
@@ -124,7 +140,7 @@
       USE phycst,  ONLY : rpi, rsmall, rad
       !! * Local declarations
-      INTEGER ::   ji,jj,jk
+      INTEGER ::   ji, jj, jk
       INTEGER ::   ii0, ii1, ij0, ij1
-      REAL(wp)::   zcoef
+      REAL(wp)::   zcoef, zwgt, ztmp, zhmin, zhmax
       !!----------------------------------------------------------------------
       IF( nn_timing == 1 )  CALL timing_start('dom_vvl_init')
@@ -155,5 +171,5 @@
       CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3u_n(:,:,:), 'U' )
       CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3v_n(:,:,:), 'V' )
-      CALL dom_vvl_interpol( fse3u_n(:,:,:), fse3f_n(:,:,:), 'F' )
+      CALL dom_vvl_interpol( fse3t_n(:,:,:), fse3f_n(:,:,:), 'F' )
       ! Vertical scale factor interpolations
       ! ------------------------------------
@@ -199,18 +215,24 @@
          hv_b(:,:) = hv_b(:,:) + fse3v_b(:,:,jk) * vmask(:,:,jk)
       END DO
-      hur_b(:,:) = umask_i(:,:) / ( hu_b(:,:) + 1. - umask_i(:,:) )
-      hvr_b(:,:) = vmask_i(:,:) / ( hv_b(:,:) + 1. - vmask_i(:,:) )
+      hur_b(:,:) = umask_i(:,:) / ( hu_b(:,:) + 1._wp - umask_i(:,:) )
+      hvr_b(:,:) = vmask_i(:,:) / ( hv_b(:,:) + 1._wp - vmask_i(:,:) )
 
       ! Restoring frequencies for z_tilde coordinate
       ! ============================================
+      tildemask(:,:) = 1._wp
+
       IF( ln_vvl_ztilde ) THEN
          ! Values in days provided via the namelist; use rsmall to avoid possible division by zero errors with faulty settings
          frq_rst_e3t(:,:) = 2.0_wp * rpi / ( MAX( rn_rst_e3t  , rsmall ) * 86400.0_wp )
          frq_rst_hdv(:,:) = 2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.0_wp )
+         ! tendency mask:
+         !
          IF( ln_vvl_ztilde_as_zstar ) THEN
             ! Ignore namelist settings and use these next two to emulate z-star using z-tilde
             frq_rst_e3t(:,:) = 0.0_wp 
             frq_rst_hdv(:,:) = 1.0_wp / rdt
+            tildemask(:,:) = 0._wp
          ENDIF
+         
          IF ( ln_vvl_zstar_at_eqtor ) THEN
             DO jj = 1, jpj
@@ -219,9 +241,11 @@
                      ! values outside the equatorial band and transition zone (ztilde)
                      frq_rst_e3t(ji,jj) =  2.0_wp * rpi / ( MAX( rn_rst_e3t  , rsmall ) * 86400.e0_wp )
-                     frq_rst_hdv(ji,jj) =  2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.e0_wp )
+!                     frq_rst_hdv(ji,jj) =  2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.e0_wp )
+              
                   ELSEIF( ABS(gphit(ji,jj)) <= 2.5) THEN
                      ! values inside the equatorial band (ztilde as zstar)
                      frq_rst_e3t(ji,jj) =  0.0_wp
-                     frq_rst_hdv(ji,jj) =  1.0_wp / rdt
+!                     frq_rst_hdv(ji,jj) =  1.0_wp / rdt
+                     tildemask(ji,jj) = 0._wp
                   ELSE
                      ! values in the transition band (linearly vary from ztilde to ztilde as zstar values)
@@ -229,8 +253,10 @@
                         &            * (  1.0_wp - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
                         &                                          * 180._wp / 3.5_wp ) )
-                     frq_rst_hdv(ji,jj) = (1.0_wp / rdt)                                &
-                        &            + (  frq_rst_hdv(ji,jj)-(1.e0_wp / rdt) )*0.5_wp   &
-                        &            * (  1._wp  - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
-                        &                                          * 180._wp / 3.5_wp ) )
+!                     frq_rst_hdv(ji,jj) = (1.0_wp / rdt)                                &
+!                        &            + (  frq_rst_hdv(ji,jj)-(1.e0_wp / rdt) )*0.5_wp   &
+!                        &            * (  1._wp  - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
+!                        &                                          * 180._wp / 3.5_wp ) )
+                     tildemask(ji,jj) = 0.5_wp * (  1._wp  - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
+                        &                                                 * 180._wp / 3.5_wp ) )
                   ENDIF
                END DO
@@ -240,7 +266,31 @@
                ij0 = 128   ;   ij1 = 135   ;   
                frq_rst_e3t( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) =  0.0_wp
-               frq_rst_hdv( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) =  1.e0_wp / rdt
+               tildemask( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) )   = 0.0_wp
+!               frq_rst_hdv( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) =  1.e0_wp / rdt
             ENDIF
          ENDIF
+         !
+         IF ( ln_vvl_zstar_on_shelf ) THEN
+            zhmin =  50._wp
+            zhmax = 100._wp
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zwgt = 1._wp
+                  IF(( ht_0(ji,jj)>zhmin).AND.(ht_0(ji,jj) <=zhmax)) THEN
+                     zwgt = (ht_0(ji,jj)-zhmin)/(zhmax-zhmin)
+                  ELSEIF ( ht_0(ji,jj)<=zhmin) THEN
+                     zwgt = 0._wp
+                  ENDIF
+                  frq_rst_e3t(ji,jj) = MIN(frq_rst_e3t(ji,jj), frq_rst_e3t(ji,jj)*zwgt)
+                  tildemask(ji,jj)   = MIN(tildemask(ji,jj), zwgt)
+               END DO
+            END DO
+         ENDIF
+         !
+         ztmp = MAXVAL( frq_rst_hdv(:,:) )
+         IF( lk_mpp )   CALL mpp_max( ztmp )                 ! max over the global domain
+         !
+         IF ( (ztmp*rdt) > 1._wp) CALL ctl_stop( 'dom_vvl_init: rn_lf_cuttoff is too small' )
+         !
       ENDIF
 
@@ -272,5 +322,5 @@
       !! Reference  : Leclair, M., and Madec, G. 2011, Ocean Modelling.
       !!----------------------------------------------------------------------
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze3t
+      REAL(wp), POINTER, DIMENSION(:,:,:) :: ze3t, ztu, ztv
       REAL(wp), POINTER, DIMENSION(:,:  ) :: zht, z_scale, zwu, zwv, zhdiv
       !! * Arguments
@@ -279,12 +329,15 @@
       !! * Local declarations
       INTEGER                                :: ji, jj, jk            ! dummy loop indices
+      INTEGER                                :: ib, ib_bdy, ip, jp    !   "     "     "
       INTEGER , DIMENSION(3)                 :: ijk_max, ijk_min      ! temporary integers
       REAL(wp)                               :: z2dt                  ! temporary scalars
       REAL(wp)                               :: z_tmin, z_tmax        ! temporary scalars
+      REAL(wp)                               :: zalpha, zwgt          ! temporary scalars
+      REAL(wp)                               :: zdu, zdv
       LOGICAL                                :: ll_do_bclinic         ! temporary logical
       !!----------------------------------------------------------------------
       IF( nn_timing == 1 )  CALL timing_start('dom_vvl_sf_nxt')
       CALL wrk_alloc( jpi, jpj, zht, z_scale, zwu, zwv, zhdiv )
-      CALL wrk_alloc( jpi, jpj, jpk, ze3t                     )
+      CALL wrk_alloc( jpi, jpj, jpk, ze3t, ztu, ztv )
 
       IF(kt == nit000)   THEN
@@ -296,5 +349,5 @@
       ll_do_bclinic = .TRUE.
       IF( PRESENT(kcall) ) THEN
-         IF ( kcall == 2 .AND. ln_vvl_ztilde ) ll_do_bclinic = .FALSE.
+         IF ( kcall == 2 .AND. ln_vvl_ztilde.OR.ln_vvl_layer ) ll_do_bclinic = .FALSE.
       ENDIF
 
@@ -307,102 +360,168 @@
       !                                                ! --------------------------------------------- !
 
-      z_scale(:,:) = ( ssha(:,:) - sshb(:,:) ) * ssmask(:,:) / ( ht_0(:,:) + sshn(:,:) + 1. - ssmask(:,:) )
+      z_scale(:,:) = ( ssha(:,:) - sshb(:,:) ) * ssmask(:,:) / ( ht_0(:,:) + sshn(:,:) + 1._wp - ssmask(:,:) )
       DO jk = 1, jpkm1
          ! formally this is the same as fse3t_a = e3t_0*(1+ssha/ht_0)
          fse3t_a(:,:,jk) = fse3t_b(:,:,jk) + fse3t_n(:,:,jk) * z_scale(:,:) * tmask(:,:,jk)
       END DO
-
-      IF( ln_vvl_ztilde .OR. ln_vvl_layer .AND. ll_do_bclinic ) THEN   ! z_tilde or layer coordinate !
-         !                                                            ! ------baroclinic part------ !
-
-         ! I - initialization
-         ! ==================
-
-         ! 1 - barotropic divergence
-         ! -------------------------
+      
+      IF((ln_vvl_ztilde .OR. ln_vvl_layer).AND.ll_do_bclinic ) THEN   ! z_tilde or layer coordinate !
+         
+         tilde_e3t_a(:,:,:) = 0.0_wp  ! tilde_e3t_a used to store tendency terms
+         un_td(:,:,:) = 0.0_wp        ! Transport corrections
+         vn_td(:,:,:) = 0.0_wp
+
          zhdiv(:,:) = 0.
-         zht(:,:)   = 0.
          DO jk = 1, jpkm1
             zhdiv(:,:) = zhdiv(:,:) + fse3t_n(:,:,jk) * hdivn(:,:,jk)
-            zht  (:,:) = zht  (:,:) + fse3t_n(:,:,jk) * tmask(:,:,jk)
-         END DO
-         zhdiv(:,:) = zhdiv(:,:) / ( zht(:,:) + 1. - tmask_i(:,:) )
-
-         ! 2 - Low frequency baroclinic horizontal divergence  (z-tilde case only)
-         ! --------------------------------------------------
-         IF( ln_vvl_ztilde ) THEN
-            IF( kt .GT. nit000 ) THEN
+         END DO
+         zhdiv(:,:) = zhdiv(:,:) / ( ht_0(:,:) + sshn(:,:) + 1._wp - tmask_i(:,:) )      
+
+         ! Thickness advection:
+         ! --------------------
+         ! Set advection velocities and source term
+         IF ( ln_vvl_ztilde ) THEN
+            !
+            IF ((kt==nit000).AND.(neuler==0)) THEN
                DO jk = 1, jpkm1
-                  hdiv_lf(:,:,jk) = hdiv_lf(:,:,jk) - rdt * frq_rst_hdv(:,:)   &
-                     &          * ( hdiv_lf(:,:,jk) - fse3t_n(:,:,jk) * ( hdivn(:,:,jk) - zhdiv(:,:) ) )
+                  ztu(:,:,jk) = un(:,:,jk)
+                  ztv(:,:,jk) = vn(:,:,jk)
+               END DO
+            ELSE
+               DO jk = 1, jpkm1
+                  ztu(:,:,jk) = (un(:,:,jk)-un_lf(:,:,jk)/fse3u_n(:,:,jk)*r1_e2u(:,:))*umask(:,:,jk)
+                  ztv(:,:,jk) = (vn(:,:,jk)-vn_lf(:,:,jk)/fse3v_n(:,:,jk)*r1_e1v(:,:))*vmask(:,:,jk)
+                  tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) + hdivn_lf(:,:,jk)
                END DO
             ENDIF
-         END IF
-
-         ! II - after z_tilde increments of vertical scale factors
-         ! =======================================================
-         tilde_e3t_a(:,:,:) = 0.0_wp  ! tilde_e3t_a used to store tendency terms
-
-         ! 1 - High frequency divergence term
-         ! ----------------------------------
-         IF( ln_vvl_ztilde ) THEN     ! z_tilde case
+            !
+         ELSEIF ( ln_vvl_layer ) THEN
+            !
             DO jk = 1, jpkm1
-               tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) - ( fse3t_n(:,:,jk) * ( hdivn(:,:,jk) - zhdiv(:,:) ) - hdiv_lf(:,:,jk) )
-            END DO
-         ELSE                         ! layer case
+               ztu(:,:,jk) = un(:,:,jk)
+               ztv(:,:,jk) = vn(:,:,jk)
+            END DO
+            !
+         ENDIF
+         !
+         ! Do advection
+         IF     (ln_vvl_adv_fct) THEN
+            CALL dom_vvl_adv_fct( kt, tilde_e3t_a, ztu, ztv )
+            !
+         ELSEIF (ln_vvl_adv_cn2) THEN
             DO jk = 1, jpkm1
-               tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) -   fse3t_n(:,:,jk) * ( hdivn(:,:,jk) - zhdiv(:,:) ) * tmask(:,:,jk)
-            END DO
-         END IF
-
-         ! 2 - Restoring term (z-tilde case only)
-         ! ------------------
+               tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) - fse3t_n(:,:,jk) * hdivn(:,:,jk)
+            END DO
+         ENDIF
+         ! 
+         ! Thickness anomlaly diffusion:
+         ! -----------------------------
+         zwu(:,:) = 0.0_wp
+         zwv(:,:) = 0.0_wp
+         ztu(:,:,:) = 0.0_wp
+         ztv(:,:,:) = 0.0_wp
+
+         IF ( ln_vvl_blp ) THEN  ! Bilaplacian
+            DO jk = 1, jpkm1
+               DO jj = 1, jpjm1                 ! First derivative (gradient)
+                  DO ji = 1, fs_jpim1   ! vector opt.                  
+                     ztu(ji,jj,jk) =  umask(ji,jj,jk) * re2u_e1u(ji,jj) &
+                                     &  * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji+1,jj  ,jk) )
+                     ztv(ji,jj,jk) =  vmask(ji,jj,jk) * re1v_e2v(ji,jj) & 
+                                     &  * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji  ,jj+1,jk) )
+                  END DO
+               END DO
+
+               DO jj = 2, jpjm1                 ! Second derivative (divergence) time the eddy diffusivity coefficient
+                  DO ji = fs_2, fs_jpim1 ! vector opt.
+                     zht(ji,jj) =  rn_ahe3_blp * r1_e12t(ji,jj) * (   ztu(ji,jj,jk) - ztu(ji-1,jj,jk)   &
+                        &                                           + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)   )
+                  END DO
+               END DO
+
+#if defined key_bdy
+               DO ib_bdy=1, nb_bdy
+                  DO ib = 1, idx_bdy(ib_bdy)%nblenrim(1)
+                     ji = idx_bdy(ib_bdy)%nbi(ib,1)
+                     jj = idx_bdy(ib_bdy)%nbj(ib,1)
+                     zht(ji,jj) = 0._wp
+                  END DO 
+               END DO
+#endif
+               CALL lbc_lnk( zht, 'T', 1. )     ! Lateral boundary conditions (unchanged sgn)
+
+               DO jj = 1, jpjm1                 ! third derivative (gradient)
+                  DO ji = 1, fs_jpim1   ! vector opt.
+                     ztu(ji,jj,jk) = umask(ji,jj,jk) * re2u_e1u(ji,jj) * ( zht(ji+1,jj  ) - zht(ji,jj) )
+                     ztv(ji,jj,jk) = vmask(ji,jj,jk) * re1v_e2v(ji,jj) * ( zht(ji  ,jj+1) - zht(ji,jj) )
+                     zwu(ji,jj) = zwu(ji,jj) + ztu(ji,jj,jk)
+                     zwv(ji,jj) = zwv(ji,jj) + ztv(ji,jj,jk)
+                  END DO
+               END DO
+            END DO
+         ENDIF
+
+         IF ( ln_vvl_lap ) THEN    ! Laplacian
+            DO jk = 1, jpkm1                    ! First derivative (gradient)
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1   ! vector opt.                  
+                     zdu =  rn_ahe3_lap * umask(ji,jj,jk) * re2u_e1u(ji,jj) &
+                         &  * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji+1,jj  ,jk) )
+                     zdv =  rn_ahe3_lap * vmask(ji,jj,jk) * re1v_e2v(ji,jj) & 
+                         &  * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji  ,jj+1,jk) )
+                     zwu(ji,jj) = zwu(ji,jj) + zdu
+                     zwv(ji,jj) = zwv(ji,jj) + zdv
+                     ztu(ji,jj,jk) = ztu(ji,jj,jk) + zdu
+                     ztv(ji,jj,jk) = ztv(ji,jj,jk) + zdv
+                  END DO
+               END DO
+            END DO
+         ENDIF 
+
+         ! Ensure barotropic fluxes are null:
+!         DO jj = 1, jpj
+!            DO ji = 1, jpi
+!               DO jk = 1, jpkm1
+!                  ztu(ji,jj,jk) = ztu(ji,jj,jk) - zwu(ji,jj)*fse3u_b(ji,jj,jk)*hur_b(ji,jj)*umask(ji,jj,jk)
+!                  ztv(ji,jj,jk) = ztv(ji,jj,jk) - zwv(ji,jj)*fse3v_b(ji,jj,jk)*hvr_b(ji,jj)*vmask(ji,jj,jk)
+!               END DO
+!            END DO
+!         END DO
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               ztu(ji,jj,mbku(ji,jj)) = ztu(ji,jj,mbku(ji,jj)) - zwu(ji,jj)
+               ztv(ji,jj,mbkv(ji,jj)) = ztv(ji,jj,mbkv(ji,jj)) - zwv(ji,jj)
+            END DO
+         END DO
+
+         ! divergence of diffusive fluxes
+         DO jk = 1, jpkm1
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  tilde_e3t_a(ji,jj,jk) = tilde_e3t_a(ji,jj,jk) + (   ztu(ji-1,jj  ,jk) - ztu(ji,jj,jk)    &
+                     &                                          +     ztv(ji  ,jj-1,jk) - ztv(ji,jj,jk)    &
+                     &                                            ) * r1_e12t(ji,jj)
+               END DO
+            END DO
+         END DO
+ 
+         un_td(:,:,:) = un_td(:,:,:) + ztu(:,:,:)
+         vn_td(:,:,:) = vn_td(:,:,:) + ztv(:,:,:)
+         CALL lbc_lnk( un_td , 'U' , -1.)
+         CALL lbc_lnk( vn_td , 'V' , -1.)  
+         !
+         !
+         ! Restoring:
          IF( ln_vvl_ztilde ) THEN
             DO jk = 1, jpk
                tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) - frq_rst_e3t(:,:) * tilde_e3t_b(:,:,jk)
             END DO
-         END IF
-
-         ! 3 - Thickness diffusion term
-         ! ----------------------------
-         zwu(:,:) = 0.0_wp
-         zwv(:,:) = 0.0_wp
-         ! a - first derivative: diffusive fluxes
+         ENDIF
+
+         ! Remove "external thickness" tendency:
          DO jk = 1, jpkm1
-            DO jj = 1, jpjm1
-               DO ji = 1, fs_jpim1   ! vector opt.
-                  un_td(ji,jj,jk) = rn_ahe3 * umask(ji,jj,jk) * re2u_e1u(ji,jj) &
-                                  & * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji+1,jj  ,jk) )
-                  vn_td(ji,jj,jk) = rn_ahe3 * vmask(ji,jj,jk) * re1v_e2v(ji,jj) & 
-                                  & * ( tilde_e3t_b(ji,jj,jk) - tilde_e3t_b(ji  ,jj+1,jk) )
-                  zwu(ji,jj) = zwu(ji,jj) + un_td(ji,jj,jk)
-                  zwv(ji,jj) = zwv(ji,jj) + vn_td(ji,jj,jk)
-               END DO
-            END DO
-         END DO
-         ! b - correction for last oceanic u-v points
-         DO jj = 1, jpj
-            DO ji = 1, jpi
-               un_td(ji,jj,mbku(ji,jj)) = un_td(ji,jj,mbku(ji,jj)) - zwu(ji,jj)
-               vn_td(ji,jj,mbkv(ji,jj)) = vn_td(ji,jj,mbkv(ji,jj)) - zwv(ji,jj)
-            END DO
-         END DO
-         ! c - second derivative: divergence of diffusive fluxes
-         DO jk = 1, jpkm1
-            DO jj = 2, jpjm1
-               DO ji = fs_2, fs_jpim1   ! vector opt.
-                  tilde_e3t_a(ji,jj,jk) = tilde_e3t_a(ji,jj,jk) + (   un_td(ji-1,jj  ,jk) - un_td(ji,jj,jk)    &
-                     &                                          +     vn_td(ji  ,jj-1,jk) - vn_td(ji,jj,jk)    &
-                     &                                            ) * r1_e12t(ji,jj)
-               END DO
-            END DO
-         END DO
-         ! d - thickness diffusion transport: boundary conditions
-         !     (stored for tracer advction and continuity equation)
-         CALL lbc_lnk( un_td , 'U' , -1._wp)
-         CALL lbc_lnk( vn_td , 'V' , -1._wp)
-
-         ! 4 - Time stepping of baroclinic scale factors
-         ! ---------------------------------------------
+            tilde_e3t_a(:,:,jk) = tilde_e3t_a(:,:,jk) +   fse3t_n(:,:,jk) * zhdiv(:,:)
+         END DO 
+                   
          ! Leapfrog time stepping
          ! ~~~~~~~~~~~~~~~~~~~~~~
@@ -412,6 +531,37 @@
             z2dt = 2.0_wp * rdt
          ENDIF
-         CALL lbc_lnk( tilde_e3t_a(:,:,:), 'T', 1._wp )
+
          tilde_e3t_a(:,:,:) = tilde_e3t_b(:,:,:) + z2dt * tmask(:,:,:) * tilde_e3t_a(:,:,:)
+
+         ! Revert to zstar locally:
+         ! ~~~~~~~~~~~~~~~~~~~~~~~~
+         DO jk=1,jpkm1
+            tilde_e3t_a(:,:,jk) =  tilde_e3t_a(:,:,jk) * tildemask(:,:) 
+         END DO
+
+         ! Ensure layer separation:
+         ! ~~~~~~~~~~~~~~~~~~~~~~~~
+         IF ( ln_vvl_regrid ) CALL dom_vvl_regrid( kt )
+  
+         ! Boundary conditions:
+         ! ~~~~~~~~~~~~~~~~~~~~
+#if defined key_bdy
+         DO ib_bdy=1, nb_bdy
+            DO ib = 1, idx_bdy(ib_bdy)%nblenrim(1)
+!!            DO ib = 1, idx_bdy(ib_bdy)%nblen(1)
+               ji = idx_bdy(ib_bdy)%nbi(ib,1)
+               jj = idx_bdy(ib_bdy)%nbj(ib,1)
+               zwgt = idx_bdy(ib_bdy)%nbw(ib,1)
+               ip = bdytmask(ji+1,jj  ) - bdytmask(ji-1,jj  )
+               jp = bdytmask(ji  ,jj+1) - bdytmask(ji  ,jj-1)
+               DO jk = 1, jpkm1  
+                  tilde_e3t_a(ji,jj,jk) = 0.e0
+!!                  tilde_e3t_a(ji,jj,jk) = tilde_e3t_a(ji,jj,jk) * (1._wp - zwgt)
+!!                  tilde_e3t_a(ji,jj,jk) = tilde_e3t_a(ji+ip,jj+jp,jk) * tmask(ji+ip,jj+jp,jk)
+               END DO
+            END DO 
+         END DO
+#endif
+         CALL lbc_lnk( tilde_e3t_a(:,:,:), 'T', 1. )        
 
          ! Maximum deformation control
